/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// graphe orienté

// les sommets sont les entiers 0,1,...,size-1

#include "prelude.h"
#include "list.h"

#ifndef DIGRAPH
#define DIGRAPH

typedef struct Digraph digraph;

digraph *digraph_create(int size);
int digraph_size(digraph *g); // nombre de sommets
void digraph_add_edge(digraph *g, int u, int v);
bool digraph_has_edge(digraph *g, int u, int v);
list *digraph_succ(digraph *g, int u);
void digraph_delete(digraph *g);

digraph *digraph_load(char *file);
void digraph_print(digraph *g);

digraph *digraph_mirror(digraph *g);
void digraph_postorder(digraph *g, int order[]);

#endif
